package org.mercury_im.messenger.persistence.room;

import android.app.Application;

import org.mercury_im.messenger.persistence.room.dao.AccountDao;
import org.mercury_im.messenger.persistence.room.dao.AvatarDao;
import org.mercury_im.messenger.persistence.room.dao.ChatDao;
import org.mercury_im.messenger.persistence.room.dao.ContactDao;
import org.mercury_im.messenger.persistence.room.dao.EntityCapsDao;
import org.mercury_im.messenger.persistence.room.dao.EntityDao;
import org.mercury_im.messenger.persistence.room.dao.MessageDao;
import org.mercury_im.messenger.persistence.room.dao.RosterInformationDao;

import javax.inject.Inject;
import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;

/**
 * Provides the {@link AppDatabase}, DAOs and Repositories.
 */
@Module(includes = RoomRepositoryModule.class)
public class RoomModule {

    private AppDatabase mAppDatabase;

    @Inject
    public RoomModule(Application application) {
        mAppDatabase = AppDatabase.getDatabase(application);
    }

    @Singleton
    @Provides
    AppDatabase provideAppDatabase() {
        return mAppDatabase;
    }

    @Singleton
    @Provides
    AccountDao provideAccountDao() {
        return mAppDatabase.accountDao();
    }

    @Singleton
    @Provides
    ContactDao provideContactDao() {
        return mAppDatabase.contactDao();
    }

    @Singleton
    @Provides
    ChatDao provideChatDao() {
        return mAppDatabase.chatDao();
    }

    @Singleton
    @Provides
    MessageDao provideMessageDao() {
        return mAppDatabase.messageDao();
    }

    @Singleton
    @Provides
    EntityDao provideEntityDao() {
        return mAppDatabase.entityDao();
    }

    @Singleton
    @Provides
    AvatarDao providerAvatarDao() {
        return mAppDatabase.avatarDao();
    }

    @Singleton
    @Provides
    RosterInformationDao provideRosterInformationDao() {
        return mAppDatabase.rosterInformationDao();
    }

    @Singleton
    @Provides
    EntityCapsDao provideEntityCapsDao() {
        return mAppDatabase.entityCapsDao();
    }
}
