package org.mercury_im.messenger.persistence.room.dao;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.Query;

import org.mercury_im.messenger.persistence.room.model.RoomRosterInformationModel;

import java.util.List;

import io.reactivex.Observable;
import io.reactivex.Single;

import static androidx.room.OnConflictStrategy.REPLACE;

@Dao
public interface RosterInformationDao extends BaseDao<RoomRosterInformationModel> {

    @Query("SELECT * FROM roster_information")
    Observable<List<RoomRosterInformationModel>> getAllRosterInformation();

    @Query("SELECT * FROM roster_information WHERE pk_account_id = :accountId")
    Observable<RoomRosterInformationModel> getRosterInformation(long accountId);

    @Insert(onConflict = REPLACE)
    Single<Long> insertRosterInformation(RoomRosterInformationModel information);
}
