package org.mercury_im.messenger.persistence.room.model;

import androidx.annotation.NonNull;
import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.Index;
import androidx.room.PrimaryKey;

import org.mercury_im.messenger.persistence.model.RosterInformationModel;

import static org.mercury_im.messenger.persistence.room.model.RoomRosterInformationModel.KEY_ID;
import static org.mercury_im.messenger.persistence.room.model.RoomRosterInformationModel.TABLE;

@Entity(tableName = TABLE, indices = {
        @Index(value = KEY_ID, unique = true)
})
public class RoomRosterInformationModel implements RosterInformationModel {

    public static final String TABLE = "roster_information";
    public static final String KEY_ID = "pk_account_id";
    public static final String KEY_ROSTER_VERSION = "roster_version";

    @PrimaryKey
    @ColumnInfo(name = KEY_ID)
    private long accountId;

    @ColumnInfo(name = KEY_ROSTER_VERSION)
    private String rosterVersion;

    @Override
    public long getAccountId() {
        return accountId;
    }

    @Override
    public void setAccountId(long accountId) {
        this.accountId = accountId;
    }

    @Override
    public String getRosterVersion() {
        return rosterVersion;
    }

    @Override
    public void setRosterVersion(String rosterVersion) {
        this.rosterVersion = rosterVersion;
    }

    @Override
    @NonNull
    public String toString() {
        return "RosterInformationModel[" +
                KEY_ID + ": " + getAccountId() + ", " +
                KEY_ROSTER_VERSION + ": " + getRosterVersion() +
                "]";
    }
}
