package org.mercury_im.messenger.persistence.repository;

import org.jxmpp.jid.EntityBareJid;
import org.mercury_im.messenger.persistence.model.AvatarModel;

import io.reactivex.Maybe;
import io.reactivex.Single;

public interface AvatarRepository<E extends AvatarModel> {

    E newAvatarModel();

    Maybe<E> getAvatarById(long avatarId);

    Maybe<E> getAvatarByEntityId(long entityId);

    Maybe<E> getAvatarByJid(EntityBareJid jid);

    Single<Long> updateOrInsertAvatar(E avatarModel);
}
